Index: /XMLIO_V2/dev/dev_rv/Makefile.wk
===================================================================
--- /XMLIO_V2/dev/dev_rv/Makefile.wk	(revision 207)
+++ /XMLIO_V2/dev/dev_rv/Makefile.wk	(revision 208)
@@ -68,9 +68,9 @@
 
 ifeq ($(PFORME), fedora-wk)
-	NETCDF_PATH = $(DEV_PATH)/netcdf4
+	NETCDF_PATH = $(DEV_PATH)/extra/netcdf4
 	INTEL_PATH  = /work/intel/composerxe
 	BOOST_PATH  = $(DEV_PATH)/extra/boost-1.44
 	RXML_PATH   = $(DEV_PATH)/extra/rapidxml-1.13
-	HDF5_PATH   = $(DEV_PATH)/hdf5
+	HDF5_PATH   = $(DEV_PATH)/extra/hdf5
 	MPI_PATH    = /usr/lib/openmpi
 endif
@@ -81,4 +81,9 @@
 VERSTR   = version $(CSUITE)
 
+
+RMDIR  = $(A)rm -rf
+REMOVE = $(A)rm -f
+COPY   = $(A)cp -f
+MKDIR  = $(A)mkdir -p
 
 ifeq ($(COMPTOOL), sx-sx8-mercure-wk)
@@ -89,7 +94,4 @@
 	AR     = $(A)sxar
 	T2F    = # indisponible
-	RMDIR  = $(A)rm -rf
-	REMOVE = $(A)rm -f
-	COPY   = $(A)cp -f 
 	DOX    = # indisponible
 	TAR    = # indisponible
@@ -107,7 +109,4 @@
 	AR     = $(A)ar
 	T2F    = # indisponible
-	RMDIR  = $(A)rm -rf
-	REMOVE = $(A)rm -f  
-	COPY   = $(A)cp -f
 	DOX    = # indisponible
 	TAR    = # indisponible
@@ -124,7 +123,4 @@
 	AR     = $(A)ar
 	T2F    = $(A)txt2tags
-	RMDIR  = $(A)rm -rf
-	REMOVE = $(A)rm -f  
-	COPY   = $(A)cp -f 
 	DOX    = $(A)doxygen -s
 	TAR    = $(A)tar -cvf
@@ -141,7 +137,4 @@
 	AR     = $(A)ar
 	T2F    = $(A)txt2tags
-	RMDIR  = $(A)rm -rf
-	REMOVE = $(A)rm -f  
-	COPY   = $(A)cp
 	DOX    = $(A)doxygen -s
 	TAR    = $(A)tar -cvf
@@ -179,14 +172,14 @@
 ############################# RÃ©pertoire du projet #############################
 
-OBJ_PATH  = $(DEV_PATH)/obj
-BIN_PATH  = $(DEV_PATH)/bin
-LIB_PATH  = $(DEV_PATH)/lib
+OBJ_PATH  = $(DEV_PATH)/wk/obj
+BIN_PATH  = $(DEV_PATH)/wk/bin
+LIB_PATH  = $(DEV_PATH)/wk/lib
 SRC_PATH  = $(DEV_PATH)/src/xmlio
-DOC_PATH  = $(DEV_PATH)/doc
-DEP_PATH  = $(DEV_PATH)/dep
-INC_PATH  = $(DEV_PATH)/include
-DATA_PATH = $(DEV_PATH)/data
-CONF_PATH = $(DEV_PATH)/conf
-SCRT_PATH = $(DEV_PATH)/script
+DOC_PATH  = $(DEV_PATH)/wk/doc
+DEP_PATH  = $(DEV_PATH)/wk/dep
+INC_PATH  = $(DEV_PATH)/wk/inc
+DATA_PATH = $(DEV_PATH)/wk/data
+CONF_PATH = $(DEV_PATH)/wk/conf
+DEF_PATH  = $(DEV_PATH)/wk/def
 
 # Sous-rÃ©pertoires des sources :
@@ -215,6 +208,6 @@
 ######################## Outils de traitements internes ########################
 
-CPPROC  = $(SCRT_PATH)/preprocess_cpp.sh
-F90ROC  = $(SCRT_PATH)/preprocess_f03.sh
+CPPROC  = $(CSRC_PATH)/preprocess_cpp.sh
+F90ROC  = $(FSRC_PATH)/preprocess_f03.sh
 
 ####################### Chemins vers la bibliothÃšque BOOST #####################
@@ -279,5 +272,5 @@
 endif
 
-NODEPS   = clean clean-all
+NODEPS   = clean clean-all dir-tree
 
 FFLAGS  += -D XIOS_LIBRARY
@@ -394,4 +387,16 @@
 .PHONY: t2t
 t2t: $(COM_T2T)
+
+.PHONY: dir-tree
+dir-tree :
+	$(MKDIR) $(OBJ_PATH)
+	$(MKDIR) $(BIN_PATH)
+	$(MKDIR) $(LIB_PATH)
+	$(MKDIR) $(DOC_PATH)
+	$(MKDIR) $(DEP_PATH)
+	$(MKDIR) $(INC_PATH)
+	$(MKDIR) $(DATA_PATH)
+	$(MKDIR) $(CONF_PATH)
+	$(MKDIR) $(DEF_PATH)
 
 .PHONY: run
Index: /XMLIO_V2/dev/dev_rv/bld.cfg
===================================================================
--- /XMLIO_V2/dev/dev_rv/bld.cfg	(revision 207)
+++ /XMLIO_V2/dev/dev_rv/bld.cfg	(revision 208)
@@ -1,3 +1,42 @@
+# ----------------------- FCM extract configuration file -----------------------
+cfg::type                           bld
+cfg::version                        1.0
 
 
+# ------------------------------------------------------------------------------
+# Build information
+# ------------------------------------------------------------------------------
 
+inc arch.fcm
+inc config.fcm
+
+%CFLAGS           %BASE_CFLAGS %COMPIL_CFLAGS
+%FFLAGS           %BASE_FFLAGS %COMPIL_FFLAGS
+%LD_FLAGS         %BASE_LD
+
+
+dest::root   $PWD
+
+bld::infile_ext::cpp   C::SOURCE
+bld::infile_ext::conf  CPP::INCLUDE
+bld::infile_ext::hpp   CPP::INCLUDE
+
+
+search_src           true
+src::xmlio XMLIO
+bld::lib::xmlio xmlio
+bld::target libxmlio.a
+bld::target main_server.exe
+bld::exe_dep
+
+bld::tool::cc        %CCOMPILER
+bld::tool::fc        %FCOMPILER
+bld::tool::cppflags  -I${PWD}/extra/include -I/usr/include
+bld::tool::ld        %LINKER
+bld::tool::ldflags   %LD_FLAGS 
+bld::tool::cflags    %CFLAGS -I${PWD}/extra/include -I/usr/include
+bld::tool::fflags    %FFLAGS -I/usr/include
+
+# Pre-process code before analysing dependencies
+bld::pp              false
+bld::excl_dep        inc::mpif.h
Index: /XMLIO_V2/dev/dev_rv/src/xmlio/data_treatment.hpp
===================================================================
--- /XMLIO_V2/dev/dev_rv/src/xmlio/data_treatment.hpp	(revision 207)
+++ /XMLIO_V2/dev/dev_rv/src/xmlio/data_treatment.hpp	(revision 208)
@@ -66,5 +66,5 @@
                                ? file->name.getValue() : file->getId();
             StdOStringStream oss;
-            oss << "data/" << filename << "_node" << comm::CMPIManager::GetCommRank() << ".nc";
+            oss << "wk/data/" << filename << "_node" << comm::CMPIManager::GetCommRank() << ".nc";
             boost::shared_ptr<io::CDataOutput> dout(new T(oss.str(), false));
             file->initializeDataOutput(dout);
Index: /XMLIO_V2/dev/dev_rv/src/xmlio/fortran/ixmlioserver.f03.in
===================================================================
--- /XMLIO_V2/dev/dev_rv/src/xmlio/fortran/ixmlioserver.f03.in	(revision 207)
+++ /XMLIO_V2/dev/dev_rv/src/xmlio/fortran/ixmlioserver.f03.in	(revision 208)
@@ -38,5 +38,5 @@
       SUBROUTINE xios_handle_create(ret, dtype, idt, idt_size) BIND(C)
          import C_CHAR, C_INTPTR_T, C_INT
-         INTEGER  (kind = C_INTPTR_T)             :: ret
+         INTEGER  (kind = C_INTPTR_T)           :: ret
          INTEGER  (kind = C_INT), VALUE         :: dtype
          CHARACTER(kind = C_CHAR), DIMENSION(*) :: idt
Index: /XMLIO_V2/dev/dev_rv/src/xmlio/fortran/preprocess_f03.sh
===================================================================
--- /XMLIO_V2/dev/dev_rv/src/xmlio/fortran/preprocess_f03.sh	(revision 208)
+++ /XMLIO_V2/dev/dev_rv/src/xmlio/fortran/preprocess_f03.sh	(revision 208)
@@ -0,0 +1,15 @@
+#!/bin/bash
+if [[ $# != 2 ]] ; then
+   echo "Usage : ./prepocess_f03.sh <output> <input>"
+   exit
+fi
+
+if test -f $2; then
+   cpp -P -o $1.temp  $2;
+   sed 's/;/\r\n/g' <$1.temp >$1
+   rm -f $1.temp
+else
+   echo "le fichier d'entrÃ©e n'existe pas !"
+fi
+
+
Index: /XMLIO_V2/dev/dev_rv/src/xmlio/iface/preprocess_cpp.sh
===================================================================
--- /XMLIO_V2/dev/dev_rv/src/xmlio/iface/preprocess_cpp.sh	(revision 208)
+++ /XMLIO_V2/dev/dev_rv/src/xmlio/iface/preprocess_cpp.sh	(revision 208)
@@ -0,0 +1,17 @@
+#!/bin/bash
+if [[ $# != 2 ]] ; then
+   echo "Usage : ./prepocess_cpp.sh <output> <input>"
+   exit
+fi
+
+if test -f $2; then
+   cpp -x c++ -P -o $1.0.temp  $2;
+   sed 's/;;/\r\n/g' <$1.0.temp >$1.1.temp
+   sed 's/INCLUDE/#include/g' <$1.1.temp >$1.0.temp
+   sed 's/\r\n \r\n/\r\n/g' <$1.0.temp >$1
+   rm -f $1.0.temp $1.1.temp
+else
+   echo "le fichier d'entrÃ©e n'existe pas !"
+fi
+
+
Index: /XMLIO_V2/dev/dev_rv/src/xmlio/node/field.hpp
===================================================================
--- /XMLIO_V2/dev/dev_rv/src/xmlio/node/field.hpp	(revision 207)
+++ /XMLIO_V2/dev/dev_rv/src/xmlio/node/field.hpp	(revision 208)
@@ -60,5 +60,7 @@
          boost::shared_ptr<CGrid> getRelGrid(void) const ;
          boost::shared_ptr<CFile> getRelFile(void) const ;
-         
+
+      public :
+
          const date::CDuration & getFreqOperation(void) const;
          const date::CDuration & getFreqWrite(void) const;