Index: /XIOS/extract_xios
===================================================================
--- /XIOS/extract_xios	(revision 303)
+++ /XIOS/extract_xios	(revision 304)
@@ -18,5 +18,5 @@
 
 
-echo -e "Installation de la bibliothÃšque xmlioserver ... "
+echo -e "Installing XIOS library... "
 
 # Traitement de la ligne de commande
@@ -44,4 +44,5 @@
    then
       read -p "Entrez le rÃ©pertoire d'extraction de la bibliothÃšque : "$PWD"/" extdir
+      read -p "insert directory path to extract XIOS library : "$PWD"/" extdir
 fi
 
@@ -52,5 +53,5 @@
 if  [[ $interactive == "true" && $has_doc == "false" ]]
    then
-      read -p "Souhaitez-vous extraire la documentation ? [Y/N]: " withdoc
+      read -p "Do you want to extract documentation ? [Y/N]: " withdoc
 fi
 
@@ -58,24 +59,24 @@
 if  [[ $interactive == "true" && $has_arch == "false" ]]
    then
-      echo -e "\r\nLe serveur d'EntrÃ©e/Sortie peut-Ãªtre installÃ©e sur diverses machine parmis lesquels : "
-      echo -e "\tIA64_PLATINE        => Configuration pour la machine de calcul Platine du CCRT !"
-      echo -e "\tX86_LOCGNU_FEDORA   => Configuration locale pour le compilateur GNU sous fedora !"
-      echo -e "\tX86_LOCINTEL_FEDORA => Configuration locale pour le compilateur intel sous fedora !\r\n"
-      echo -e "\tX64_TITANE          => Configuration pour la machine de calcul Titane du CCRT  !\r\n"
+      echo -e "\r\n XIOS may be install on different computing architecture, choose witch one...\r\n "
+      echo -e "\tIA64_PLATINE        => Configuration for CCRT supercomputer Platine\r\n"
+      echo -e "\tX86_LOCGNU_FEDORA   => Local configuration for gnu compiler under fedora\r\n"
+      echo -e "\tX86_LOCINTEL_FEDORA => Local configuration for intel compiler under fedora \r\n"
+      echo -e "\tX64_TITANE          => Configuration for CCRT supercomputer Titane \r\n"
       
-      read -p "Sur quelle architecture travaillez-vous ? (aucune par dÃ©faut): " arch
+      read -p "On which architecture do you want to work ? (default : none): " arch
 fi
 
 case $arch in
    IA64_PLATINE)        
-      echo "=> Configuration pour la machine de calcul Platine du CCRT !" ;;
+      echo "=> Configuration for CCRT supercomputer Platine" ;;
    X86_LOCGNU_FEDORA)   
-      echo "=> Configuration locale pour le compilateur GNU sous fedora !" ;;
+      echo "=> Local configuration for gnu compiler under fedora" ;;
    X86_LOCINTEL_FEDORA) 
-      echo "=> Configuration locale pour le compilateur intel sous fedora !" ;;
+      echo "=> Local configuration for intel compiler under fedora" ;;
    X64_TITANE) 
-      echo "=> Configuration pour la machine de calcul Titane du CCRT  !" ;;
+      echo "=> Configuration for CCRT supercomputer Titane " ;;
    *)                   
-      echo "=> Aucune configuration d'installation !"
+      echo "=> no specific architecture choosen"
       arch=
 esac
@@ -84,6 +85,6 @@
 if  [[ $interactive == "true" && $has_user  == "false" ]]
    then
-      echo -e -n "Veuillez Ã  prÃ©sent indiquer votre identifiant de connexion au serveur svn"
-      read -p " forge.ipsl.jussieu.fr (Ne rien Ã©crire si anonyme) : " svnuser
+      echo -e -n "insert your svn login"
+      read -p " forge.ipsl.jussieu.fr (nothing if anonymous) : " svnuser
 fi
 
@@ -91,5 +92,5 @@
 if  [[ $interactive == "true" && $has_branch == "false" ]]
    then
-      read -p "Quelle branche souhaitez-vous extraire ? (/trunk par dÃ©faut): " svnbranch
+      read -p "Which branch do tou want to extract ? (default : /trunk): " svnbranch
 fi
 
@@ -107,5 +108,5 @@
 
 # Extraction de la distribution
-echo -e "=> Connexion au serveur svn via \""$connect"\"..."
+echo -e "=> Connecting to svn server via \""$connect"\"..."
 
 
@@ -117,5 +118,5 @@
 svn -q co $connect  $install_dir
 
-echo -e "- DÃ©compression des archives ..."
+echo -e "- uncompress archives ..."
 cd $install_dir
 for tarname in $install_dir/tools/archive/*.tar.gz; do
@@ -125,5 +126,5 @@
 if [[ !(-z $arch) && -f $install_dir/make_xios ]]
    then
-      echo -e "ExÃ©cution du script d'installation local pour l'architecture \""$arch"\" ..."
+      echo -e "Running installation script for architecture \""$arch"\" ..."
       installopt=$installopt" --"$compil_mode" --arch "$arch
       cd $install_dir && ./make_xios $installopt